package pl.net.linux.krzak.kchat.applet;
import java.io.*;
import java.net.Socket;

public class kChatNet extends Thread {
    Socket         clientS    = null;
    BufferedReader br         = null;
    PrintWriter    pw         = null;
    kChatApplet    applet     = null;
    kChatProtocol  protocol   = null;
    private boolean connected = true;

    public kChatNet(String hosttmp,String port,kChatApplet a) throws IOException
    {
    if ((port == null) || (port.equals(""))) { port = new String("1979"); }
    clientS = new Socket(hosttmp,new Integer(port).parseInt(port));
    br = new BufferedReader(new InputStreamReader(clientS.getInputStream()));
	
    pw = new PrintWriter(new BufferedWriter(new OutputStreamWriter(clientS.getOutputStream())),true);
    applet = a;
    start();
    }

    public void run()
    {
	try {
		protocol = new kChatProtocol(applet);
		while (connected) {
		 String input = new String(br.readLine());
		 if (input == null) break;
		 protocol.parse(input);
		}
	} 
	catch (IOException e) { }
	catch (NullPointerException ne) { 
		applet.chanWnd.appendText(applet.TXT[18],applet.msgColor);
	}
	finally { 
	    try {  clientS.close(); System.out.println("connection lost :)");	 } catch (IOException e2) { }  
	}
    }

    public synchronized void disconnect() {
	send("*CLOSE");
 
	connected=false;
	try { clientS.close();
 } catch (IOException e) {}
    }

    public synchronized void send(String data) {
	if ((data != null)&&(pw!=null)){
	    data.trim();
	    pw.println(data);
	    } else disconnect();
    }


}
