package pl.net.linux.krzak.kchat.applet;
import java.awt.*;
import pl.net.linux.krzak.kchat.util.kChatParse;

public class kChatProtocol {
    private pl.net.linux.krzak.kchat.util.kChatParse parse = new pl.net.linux.krzak.kchat.util.kChatParse();
    private kChatApplet applet = null;

    public kChatProtocol(kChatApplet a) {
 applet = a;
 }

    public void parse(String buf) {
    
    System.out.println(buf);

    if ((buf==null) || (buf.equals(""))) return;

    if (buf.startsWith("*MSG"))
 {
	String who = parse.getParam(buf,2);
	String where = parse.getParam(buf,3);
	String text = parse.getParam(buf,4);
	String color = parse.getParam(buf,5);
        String s = "<"+who+"> "+text;
	if (where.equals("CHAN")) { applet.chanWnd.appendText(s,color); return; }
	// priv, lub do moderatora
	if (where.equals(applet.login))
 {
	    if (applet.moderate && where.equals(applet.moderatorNick)) { // to pisze ludek do moderatora
		applet.moder.textarea.appendText(s,color);
	    } else {
    		if  ((applet.alreadyExistNick(who) == false)) {
			if (!buf.startsWith("*MSGCLOSE")) {
			 MsgFloatingWindow fw = new MsgFloatingWindow(applet.compileText(applet.TXT[12],who),who,applet);
			 fw.setVisible(true);
			 fw.text.append("*<"+ who +">* " + text + "\n");
			 }
			} else {
			if (!buf.startsWith("*MSGCLOSE")) {
			 MsgFloatingWindow fw = applet.getMsgWindowFromList(who);
			 fw.text.append("*<"+ who +">* " + text + "\n");
			 } else {
			 MsgFloatingWindow fw = applet.getMsgWindowFromList(who);
			 fw.text.append(text + "\n");
			 }
		}
	    }
	}
	
    return;
    }
    
    if (buf.startsWith("*LIST"))
 {
	if (applet.nList == null) applet.nList = new List();

	int start = 5;	int end = 5;
	while (buf.indexOf("|",start+1) != -1) {
	    start = end+1;
	    end   = buf.indexOf("|",start+1);
	    if ((start<end) && (!buf.substring(start,end).equals(applet.login))) applet.nList.add(buf.substring(start,end));
	    }
    }

    if (buf.startsWith("*JOIN"))
 {
	String n = parse.getParam(buf,2);
	applet.nList.add(n);
	if (applet.moderate == false) 
	    applet.chanWnd.appendText(applet.compileText(applet.TXT[2],n),applet.alertColor); // "przyszedl"
    }

    if (buf.startsWith("*QUIT"))
 {
	String n = parse.getParam(buf,2);
	for (int i=0;i<applet.nList.getItemCount();i++) {
		if ((applet.nList != null) && (applet.nList.getItem(i).equals(n)))
 applet.nList.remove(i);
	    }
	applet.chanWnd.appendText(applet.compileText(applet.TXT[5],n),applet.alertColor); // "wyszedl"
    	if  (applet.alreadyExistNick(n)) {
		MsgFloatingWindow fw = applet.getMsgWindowFromList(n);
		if (applet.moderate == false) fw.text.append(applet.compileText(applet.TXT[5],n)); // "wyszedl"
	}
    }

    if (buf.startsWith("*MODERATED")) {
	if (buf.substring(11,13).equals("NO")) {
	    applet.moderate=false;
	    applet.moderatorNick = "";
	    applet.chanWnd.appendText(applet.TXT[4] ,applet.alertColor); // "kanal nie jest moderowany"
	    } else {
	    applet.moderate=true;
	    applet.moderatorNick = parse.getParam(buf,3);
	    if (!applet.moderatorNick.equals(applet.login) && (applet.moder != null)) {
		/* zamkniecie okna moderatora */
		applet.moder.stopModerator();
		}
	    applet.chanWnd.appendText(applet.compileText(applet.TXT[3],applet.moderatorNick),applet.alertColor); // "kanal moderowany przez "
	    }
    }

    if (buf.startsWith("*YOUAREMODERATOR")) {
	    applet.moderate=true;
	    applet.chanWnd.appendText(applet.compileText(applet.TXT[14],applet.chan),applet.alertColor); // "jestes moderatorem"
	    applet.bPrivate.setLabel(applet.TXT[16]);
	    applet.bPrivate.setActionCommand("KICK");
	    applet.bModerator.setLabel(applet.TXT[17]);
	    applet.bModerator.setActionCommand("TOPIC");
	    applet.moder = new kChatModerator("MODERATOR",applet);
    }

    if (buf.startsWith("*LOGIN"))
{ 
	    String s = parse.getParam(buf,2);
	    if (s.equals("OK")) {
		// get login from serwer !!!
		applet.login=parse.getParam
(buf,3);
		try {
		applet.logouthtml = new java.net.URL(parse.getParam(buf,4));
		} catch (java.net.MalformedURLException e) {
//		    e.printStackTrace();
		}
		applet.chanWnd.appendText(applet.TXT[0],applet.alertColor);
		applet.net.send("*MODERATED");
		}
	    if (s.equals("NICK BUSY")) {
		applet.chanWnd.appendText(applet.TXT[11],applet.alertColor); // "login zajety"
		}

	}
    if (buf.startsWith("*KICK"))
 {
	applet.chanWnd.appendText(applet.TXT[15],applet.alertColor);
	applet.net.send("*CLOSE\r\n");
	applet.net.disconnect();
	applet.net=null;
	applet.actions=null;
	applet.context.showDocument(applet.logouthtml,"_self");
	applet = null;
    }

    if (buf.startsWith("*PING"))
 {
	applet.net.send("*PONG\r\n");
    }

    if (buf.startsWith("*LANG"))
 {
	for (int i=0;i<applet.TXT.length;i++) {
	    applet.TXT[i] = parse.getParam(buf,i+2);
	    }
	applet.bPrivate.setLabel(applet.TXT[6]);
	applet.bModerator.setLabel(applet.TXT[7]);
	applet.bLogout.setLabel(applet.TXT[8]);
	applet.bClose.setLabel(applet.TXT[9]);
    }

    if (buf.startsWith("*TOPIC|GET|")) {
	applet.topicLabel.setText("["+applet.chan + "] <-> " + parse.getParam(buf,3));
    }

  }


}